package io.irandom.messaging; 

import salsa.language.ServiceFactory;

import wwc.messaging.PersistentMessenger;

import io.core.messaging.PeerTheater;
import io.random.messaging.RandomHandler;
import io.random.messaging.RandomProtocolHandler;
import io.irandom.decision.IRandomDecisionAgent;

public class IRandomPeerTheater extends PeerTheater {

	private static IRandomPeerTheater instance = new IRandomPeerTheater();

	public IRandomPeerTheater() {
		super();
	}

	public static PeerTheater getInstance() {
		return (PeerTheater)instance;
	}

	public static void main(String[] args) {
		ServiceFactory.createFactory(getInstance(), new PersistentMessenger(), new RandomHandler(), null);

		getInstance().decider = new IRandomDecisionAgent(100, 100);
		getInstance().protocolHandler = new IRandomProtocolHandler();

		getInstance().initialize(args);

		getInstance().decider.start();
		getInstance().startTheater();
	}
}
