package io.srandom.decision;

import java.util.Vector;
import salsa.language.ActorReference;
import salsa.language.ServiceFactory;
import io.core.decision.DecisionAgent;
import io.core.language.*;
import io.core.messaging.*;
import io.random.protocol.RandomSteal;
import io.random.language.RandomActor;
import io.random.decision.RandomDecisionAgent;

public class SRandomDecisionAgent extends RandomDecisionAgent implements DecisionAgent {

	//Waiting determines if the decision agent will originate another random stealing packet.
	private boolean waiting = false;
	private IOTheater theater;

	public SRandomDecisionAgent() {
		super();
		theater = (IOTheater)ServiceFactory.getTheater();
	}

	public IOActor getBestCandidate() {
		//returns the best candidate actor to migrate to the given theater

		IOActor candidate = null;

		synchronized( theater.getRegistry() ) {
			Vector registry = new Vector(theater.getRegistry().values());

			double candidateSatisfaction = -1;

			for (int i = 0; i < registry.size(); i++) {
				Object current = registry.get(i);

				if (current instanceof RandomActor) {
					if ( !((RandomActor)current).scheduled() && 
					     !((RandomActor)current).satisfied() && 
					     (((RandomActor)current).satisfaction() > candidateSatisfaction)) {
						candidate =(RandomActor) current;
						candidateSatisfaction = candidate.satisfaction();
					}
				}
			}
		}

		return candidate;
	}
}
