package io.srandom.messaging; 

import salsa.language.ServiceFactory;

import wwc.messaging.PersistentMessenger;

import io.core.messaging.PeerTheater;
import io.random.messaging.RandomHandler;
import io.random.messaging.RandomProtocolHandler;
import io.srandom.decision.SRandomDecisionAgent;

public class SRandomPeerTheater extends PeerTheater {

	private static SRandomPeerTheater instance = new SRandomPeerTheater();

	public SRandomPeerTheater() {
		super();
	}

	public static PeerTheater getInstance() {
		return (PeerTheater)instance;
	}

	public static void main(String[] args) {
		ServiceFactory.createFactory(getInstance(), new PersistentMessenger(), new RandomHandler(), null);

		getInstance().decider = new SRandomDecisionAgent();
		getInstance().protocolHandler = new RandomProtocolHandler();

		getInstance().initialize(args);

		getInstance().decider.start();
		getInstance().startTheater();
	}
}
